# -*- coding: utf-8 -*-

from django.conf import settings
from django.core.cache import cache
from django.utils.cache import *
from django.http import HttpRequest

def cache_force_view_expiration(path, key_prefix=None):
	"""
	Deletes the view matching the given path (absolute URL) from Django cache.

	Exemple:
	from django.pimentech.cache import cache_force_view_expiration

	cache_force_view_expiration('/my-app/my-view-1234/')
	
	"""
	request = HttpRequest() 
	request.path = path

	if key_prefix is None:
		key_prefix = settings.CACHE_MIDDLEWARE_KEY_PREFIX
	
	cache_key = get_cache_key(request, key_prefix)
	if cache_key is not None and cache.has_key(cache_key):
		cache.delete(cache_key)
		return True
	return False
