# -*- coding: utf-8 -*-

from django.db import models

class ChatUser(models.Model):
	name = models.CharField(maxlength=16)
	online = models.BooleanField()
	last_connection = models.DateTimeField('last connection date', auto_now_add=True)
	last_ip_address = models.CharField(maxlength=15)
	last_message_check = models.DateTimeField('last message check', auto_now=True)

	def __str__(self):
		return self.name

	class Admin:
		pass

class Message(models.Model):
	name = models.TextField()
	date = models.DateTimeField('message date', auto_now_add=True)
	ip_address = models.CharField(maxlength=15)
	chat_user = models.ForeignKey(ChatUser, verbose_name='chat user')
	color = models.TextField(default='black')
	
	def __str__(self):
		out = self.name
		if len(out) > 15:
			return out[:15] + '(...)'
		else:
			return out

	class Admin:
		pass
	
