# -*- coding: utf-8 -*-

import django.contrib.sitemaps

class Sitemap(django.contrib.sitemaps.Sitemap):
	"""
	A sitemap class without the domain stuff !
	"""

	def host(self):
		"""
		redefine this function in your module !
		"""
		raise "redefine the host() function !"
	
	def get_urls(self):
		urls = []
		for item in self.items():
			url_info = {
				'location':   "%s%s" % (self.host(), self.__get('location', item)),
				'lastmod':	  self.__get('lastmod', item, None),
				'changefreq': self.__get('changefreq', item, None),
				'priority':	  self.__get('priority', item, None)
			}
			urls.append(url_info)
		return urls

class GenericSitemap(django.contrib.sitemaps.GenericSitemap):
	"""
	A generic sitemap class without the domain stuff !
	"""
	
	def host(self):
		"""
		redefine this function in your module !
		"""
		raise "redefine the host() function !"

	def __get(self, name, obj, default=None):
		try:
			attr = getattr(self, name)
		except AttributeError:
			return default
		if callable(attr):
			return attr(obj)
		return attr

	def get_urls(self):
		urls = []
		for item in self.items():
			url_info = {
				'location':   "%s%s" % (self.host(), self.__get('location', item)),
				'lastmod':    self.__get('lastmod', item, None),
				'changefreq': self.__get('changefreq', item, None),
				'priority':   self.__get('priority', item, None),
			}
			urls.append(url_info)
		return urls
