# -*- coding: utf-8 -*-

from django.newforms import *
from django import oldforms
from django.core import validators

attrs_dict = { 'class': 'required' }

class RegisterForm(Form):
	username = EmailField(required=True, label=_("nom d'utilisateur (email valide)"))
	last_name = CharField(required=True, label=_('nom'))
	first_name = CharField(required=True, label=_('prenom'))


class PasswordChangeForm(oldforms.Manipulator):
	"A form that lets a user change his password."
	def __init__(self, user):
		self.user = user
		self.fields = (
			oldforms.PasswordField(field_name="old_password", length=30, maxlength=30, is_required=True,
				validator_list=[self.isValidOldPassword]),
			oldforms.PasswordField(field_name="new_password1", length=30, maxlength=30, is_required=True,
				validator_list=[validators.AlwaysMatchesOtherField('new_password2', _("The two 'new password' fields didn't match.")), self.isValidLengthPassword]),
			oldforms.PasswordField(field_name="new_password2", length=30, maxlength=30, is_required=True),
		)
		
	def isValidOldPassword(self, new_data, all_data):
		"Validates that the old_password field is correct."
		if not self.user.check_password(new_data):
			raise validators.ValidationError, _("Your old password was entered incorrectly. Please enter it again.")

	def isValidLengthPassword(self, field_data, all_data):
		if not len(field_data) >= 6:
			raise validators.ValidationError, _("Your password length must be 6 chars at least.")
	
	def save(self, new_data):
		"Saves the new password."
		self.user.set_password(new_data['new_password1'])
		self.user.save()

	
