# -*- coding: utf-8 -*-

from django.contrib.auth import authenticate, login, logout
from django.contrib.sites.models import Site
from django.contrib.auth.models import User
from django.contrib.auth.forms import PasswordResetForm


from django.shortcuts import render_to_response
from django.template import RequestContext
from django.template.loader import render_to_string



from django.pimentech.utils import get_object_or_404
from django.http import Http404, HttpResponseRedirect
from django.db import transaction

from django.utils.translation.trans_real import gettext as _
from django.core.mail import send_mail

from django.contrib.auth.views import login as generic_login_view

from django.pimentech.authentification.forms import * 


def login_view(request, redirect_to=None):
	template_name="authentification/login.html"
	redirect_to = request.REQUEST.get('next', '')
	return generic_login_view(request, template_name=template_name) 

def logout_view(request):
	logout(request)
	return HttpResponseRedirect(request.GET.get('next', ''))

def password_reset(request, is_admin_site=False, email_template_name='authentification/password_reset_email.html'):
	new_data, errors = {}, {}
	form = PasswordResetForm()

	if request.POST:
		new_data = request.POST.copy()
		errors = form.get_validation_errors(new_data)
		if not errors:
			if is_admin_site:
				form.save(domain_override=request.META['HTTP_HOST'])
			else:
				form.save(email_template_name=email_template_name)
				return HttpResponseRedirect('%sdone/' % request.path)
	return render_to_response('authentification/password_reset_form.html',\
			{'form': oldforms.FormWrapper(form, new_data, errors)},
			 context_instance=RequestContext(request))

def password_reset_done(request):
	return render_to_response('authentification/password_reset_done.html',\
			{},\
			context_instance=RequestContext(request))

def password_change(request, customer):
	new_data, errors = {}, {}
	form = PasswordChangeForm(customer)
	if request.POST:
		new_data = request.POST.copy()
		errors = form.get_validation_errors(new_data)
		if not errors:
			form.save(new_data)
			return HttpResponseRedirect('%sdone/' % request.path)
	return render_to_response('authentification/password_change_form.html',\
			{'form': oldforms.FormWrapper(form, new_data, errors)},
			context_instance=RequestContext(request))

def password_change_done(request, customer):
	return render_to_response('authentification/password_change_done.html',\
			{}, context_instance=RequestContext(request))

