# -*- coding: utf-8 -*-

from models import *
import datetime

def get_user(user_name):
	# returns a user by nickname, None if it doesn't exists
	try:
		user = ChatUser.objects.get(name=user_name)
		return user
	except ChatUser.DoesNotExist:
		return None	

def get_user_online(user_name):
	# returns a user by nickname if connected else None
	user = get_user(user_name)
	if user and user.online:
		return user
	return None

def check_logged(user_name, ip):
	# checks user logged and IP address is correct
	user = get_user_online(user_name)
	if user.last_ip_address == ip:
		return user
	else:
		return None

def check_timeout(seconds = 30):
	# disconnect users that have not checked messages for a number of seconds
	for user in ChatUser.objects.filter(online = True): # TODO : try to improve performances here
		if (datetime.datetime.now() - user.last_message_check).seconds > seconds:
			user.online = False
			user.save()

