# -*- coding: utf-8 -*-

from django.pimentech.network import *
from models import *
from lib import *
from django.http import HttpResponse


chatservice = JSONRPCService()

# python2.4
# @jsonremote(chatservice, 'login')
def login(request, user_name):
	user = get_user(user_name)
	if user:
		if user.online:
			return False
		user.online = True
		user.last_ip_address = request.META['REMOTE_ADDR']
	else:
		user = ChatUser(name=user_name, last_ip_address=request.META['REMOTE_ADDR'], online=True)
	user.save()
	return True

def logout(request, name):
	user = check_logged(name, request.META['REMOTE_ADDR'])
	if user and user.online:
		user.online = False
		user.save()
		return True
	return False

def post_message(request, name, message, color = 'black'):
	user = check_logged(name, request.META['REMOTE_ADDR'])
	if user:
		message = Message(name=message, chat_user=user, ip_address=request.META['REMOTE_ADDR'], color=color)
		message.save()
		return True
	else:
		return False

def get_messages(request, name, nb_messages = 15):
	out = []
	user = check_logged(name, request.META['REMOTE_ADDR'])
	if user:
		user.save() # in order to update last_message_check
		messages = Message.objects.all()
		if len(messages) > nb_messages:
			messages = messages[len(messages) - nb_messages:]
		for message in messages:
			out.append({'user_name': message.chat_user.name.decode('utf-8'), 'message': message.name.decode('utf-8'), 'time': message.date.strftime('%H:%M:%S'), 'color': message.color })
	return out

def online_users(request, name):
	out = []
	user = check_logged(name, request.META['REMOTE_ADDR'])
	if user:
		check_timeout()
		for user in ChatUser.objects.filter(online=True):
			out.append({'user_name': user.name.decode('utf-8'), 'login_date': user.last_connection.strftime('%H:%M:%S'), 'ip': user.last_ip_address})
	return out

# python2.3
chatservice.add_method("login", login)
chatservice.add_method("logout", logout)
chatservice.add_method("get_messages", get_messages)
chatservice.add_method("post_message", post_message)
chatservice.add_method("online_users", online_users)
