from django.conf import settings
from django.shortcuts import render_to_response
from django.template import RequestContext
from django.http import HttpResponse, HttpResponseRedirect, get_host

from libcommon.log import *
from libcommon.mailing import *
from libcommon.mail import *
import globals

import re
import urllib



def index_html(request):
    return render_to_response('mailing/index.html',
                              {},
                              context_instance = RequestContext(request)
							  )

class Mailing(CSVMailing):
	def send_mail(self, email):
		self.mail_message = mail.MailMessage2(self.charset)
		self.mail_message.addHeader('To', email, 'iso-8859-1')
		self.mail_message.addHeader('From', self.sender, 'iso-8859-1')
		self.mail_message.addHeader('Subject', self.subject, 'iso-8859-1')
		self.mail_message.addHtml(self.message.replace('charset=utf-8', 'charset=iso-8859-1', 1), 'iso-8859-1')

		self.mail_server = mail.SmtpClient('localhost', 25, self.log)

		try:
			self.mail_server.send_message(self.sender, email, self.mail_message.message())
			self.log.message("Sending message to %s" % email)
		except (SMTPRecipientsRefused, SMTPSenderRefused), msg:
			self.log.warning("incorrect email: %s or pb smtp %s" % (email, sys.exc_value))
			return None
		return 1

	def load(self):
		for line in self.data:
			try:
				(email, ) = line
				yield "Sending message to %s<br />" % email
			except:
				yield "wrong line (1 fields expected) :<br />%s<br />" % join(line, '|')
			self.load_line(line)
		yield "Mailing sent!"


def send(request):
	"Send mailing"
	sender = request['sender']
	subject = request['subject']
	recipients_url = request['recipients_url']
	message_url = request['message_url']
	delay = float(request.POST.get('delay', 2))
	smtphost = request.POST.get('smtphost', 'localhost')
	charset = 'utf-8'
	log = LOG(globals.LOGFILE)
	message = urllib.urlopen(message_url).read()
	csv = Mailing(smtphost, recipients_url, sender, subject, message, log, charset, delay)
	return HttpResponse(csv.load())
